# -*- coding: utf-8 -*-
import os
import time
import oss2
import xml.etree.ElementTree as ET
import shutil
import docker
import logging

key1 = 'pjisuv/'
path1 = '/scenarios3/'
path2 = '/mnt/disk001/dcl_data_process/src/python2/pjisuv/'
path3 = '/mnt/disk001/simulation_pjisuv/'

logging.basicConfig(filename=path2 + 'log/simulation-pjisuv.log', level=logging.INFO,
                    format='%(asctime)s - %(levelname)s - %(message)s')

sleep_time = 60  # 每多少秒扫描一次


def move_xosc_before_simulation(root_path):
    try:

        xodr = 'OpenDRIVE2_add_stop_line_marking_20231229.xodr'
        osgb = 'jinlong_all_addtrafficlight_20240226_5_guazai_2.opt.osgb'

        tree1 = ET.parse(root_path1 + 'scenario_orig.xosc')
        root1 = tree1.getroot()
        for node0 in root1:
            if node0.tag == 'RoadNetwork':
                for node1 in node0:
                    # 打印根元素的标签名
                    src_file_prefix = path3
                    if 'LogicFile' == node1.tag:
                        if xodr in node1.get('filepath'):
                            dst_file = root_path1 + xodr
                            shutil.copy(src_file_prefix + xodr, dst_file)
                            node1.set('filepath', dst_file)
                        if xodr in node1.get('filepath'):
                            dst_file = root_path1 + xodr
                            shutil.copy(src_file_prefix + xodr, dst_file)
                            node1.set('filepath', dst_file)
                        if xodr in node1.get('filepath'):
                            dst_file = root_path1 + xodr
                            shutil.copy(src_file_prefix + xodr, dst_file)
                            node1.set('filepath', dst_file)
                    if 'SceneGraphFile' == node1.tag:
                        if osgb in node1.get('filepath'):
                            dst_file = root_path1 + osgb
                            shutil.copy(src_file_prefix + osgb, dst_file)
                            node1.set('filepath', dst_file)
                        if osgb in node1.get('filepath'):
                            dst_file = root_path1 + osgb
                            shutil.copy(src_file_prefix + osgb, dst_file)
                            node1.set('filepath', dst_file)
                        if osgb in node1.get('filepath'):
                            dst_file = root_path1 + osgb
                            shutil.copy(src_file_prefix + osgb, dst_file)
                            node1.set('filepath', dst_file)
            if node0.tag == 'Entities':
                for node1 in node0:
                    if node1.get("name") == 'Ego':
                        for node2 in node1:
                            if node2.tag == 'Vehicle':
                                node2.set('name', 'Pji_Utility_Vehicle')
        tree1.write(root_path1 + 'openx0.xosc')

    except Exception as e:
        logging.exception("修改xosc报错: %s" % str(e))


def upload_simulation(parse_prefix, mp41):
    try:
        bucket.put_object_from_file(parse_prefix + 'scenario_orig.mp4', mp41)
        logging.info('上传仿真视频到 %s' % parse_prefix + 'scenario_orig.mp4')
        # bucket.put_object_from_file(parse_prefix + 'scenario_hmi.mp4', mp42)
        # logging.info('上传仿真视频到 %s' % parse_prefix + 'scenario_hmi.mp4')
        shutil.rmtree(path1)  # todo 仿真完就删除了，所以不需要 local_delete_list
    except Exception as e:
        logging.exception("上传视频报错 %s" % str(e))


def simulation(parse_prefix, mp41):
    try:
        os.system("docker start vtd3")
        # 实例化Docker客户端
        client = docker.from_env()
        while True:
            time.sleep(5)
            # 获取容器列表
            containers = client.containers.list()
            run = False
            # 打印容器列表
            for container in containers:
                if 'vtd3' == container.name:
                    run = True
                    break
            if not run:
                break
        time.sleep(5)
        upload_simulation(parse_prefix, mp41)
    except Exception as e1:
        logging.exception("生成仿真视频报错 %s" % str(e1))


def is_upload_completed(bucket, prefix):
    target_number = str(prefix).split('_')[-1][:-1]
    count = 0
    for obj in oss2.ObjectIterator(bucket, prefix=prefix):
        if obj.key != prefix:
            count += 1
    return int(count) == int(target_number)


# ------- 获取合并之后的bag包，解析出csv -------
if __name__ == '__main__':
    # 1 创建阿里云对象
    auth = oss2.Auth('n8glvFGS25MrLY7j', 'xZ2Fozoarpfw0z28FUhtg8cu0yDc5d')
    endpoint = 'oss-cn-beijing-gqzl-d01-a.ops.gqzl-cloud.com'
    bucket = oss2.Bucket(auth, endpoint, 'open-bucket')
    while True:
        logging.info("开始新一轮扫描")
        oss_delete_list = []
        prefix_list = []
        # 2 获取已经上传完成的所有目录并分组
        all_prefix_set = set()
        for obj1 in oss2.ObjectIterator(bucket, prefix=key1):
            # 获取csv
            if 'data_parse' in str(obj1.key) and str(obj1.key).count('/') == 4:
                all_prefix_set.add('/'.join(str(obj1.key).split('/')[:-1]) + '/')
        for obj2_key in all_prefix_set:
            xosc1_done = False
            mp41_done = False
            for obj3 in oss2.ObjectIterator(bucket, prefix=obj2_key):
                if '/scenario_orig.xosc' in str(obj3.key):
                    xosc1_done = True
                if '/scenario_orig.mp4' in str(obj3.key):
                    mp41_done = True
            if not xosc1_done or mp41_done:
                continue

            logging.info("需要生成仿真视频: %s" % obj2_key)
            parse_prefix_full = obj2_key
            local_dir_full = path1 + parse_prefix_full
            if not os.path.exists(local_dir_full):
                os.makedirs(local_dir_full)
            # 下载两个csv
            root_path1 = local_dir_full + 'orig/'
            if not os.path.exists(root_path1):
                os.makedirs(root_path1)

            bucket.get_object_to_file(parse_prefix_full + 'scenario_orig.xosc', root_path1 + 'scenario_orig.xosc')
            move_xosc_before_simulation(root_path1)
            simulation(parse_prefix_full, root_path1 + 'simulation.mp4')
        time.sleep(sleep_time)
